package de.uni_mannheim.app;

import java.util.Enumeration;
import java.util.Vector;

import javax.microedition.lcdui.List;

import de.uni_mannheim.aware.api.location.LocationData;

public class TestAbc {
	static double kmh = 50;		
	static double ms = kmh/3.6;
	

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		LocationData[] waypoints = new LocationData[] {
			new LocationData(49.481,8.471), // L15
			new LocationData(49.4828,8.47299), // Kaiserring am Cinemax
			new LocationData(49.48637,8.4638), // Nahe Kochschule (Zwischenpunkt)
			new LocationData(49.48765,8.4604), // Kreuzung C5
			new LocationData(49.48685,8.4596), // Parkplatz B6
			new LocationData(49.4875,8.4579), // B6
		};
		
		Vector intervalWaypoints = new Vector();
		
		for (int i=0; i<waypoints.length-1; i++) {
			LocationData a = waypoints[i];
			LocationData b = waypoints[i+1];
			
			intervalWaypoints.addElement(a);
			
			// Calculate next waypoint (until we are beyond the destination, = b)
			boolean beyond = false;
			
			while (!beyond) {
				LocationData c = calculateNextWaypoint(a, b);
				
				beyond = c == null;
				
				// If not beyond destination (= b), add it
				if (!beyond) {
					intervalWaypoints.addElement(c);
					a = c;
				}
			} 
			
			if (i == waypoints.length-2)
				intervalWaypoints.addElement(b);
		}
		
		for (Enumeration e = intervalWaypoints.elements(); e.hasMoreElements(); ) {
			LocationData c = (LocationData) e.nextElement();
			
			//System.out.println(c.getLatitude()+","+c.getLongitude());
			System.out.println("		this.m.addOverlay(new GMarker(new GLatLng("+c.getLatitude()+","+c.getLongitude()+"), markerOptions));");
		}
		
		System.out.println("Waypoints: "+intervalWaypoints.size());
	}
	
	/**
	 * 
	 * @author Philipp Heckel 
	 * @param a
	 * @param b
	 * @return
	 */
	public static LocationData calculateNextWaypoint(LocationData a, LocationData b) {		
		double d = a.distance(b);

		//// Between a and b ////
		
		// Horizontal and vertical direction (required for determining the last point)
		double latdir = (a.getLatitude() > b.getLatitude()) ? -1 : 1;
		double lngdir = (a.getLongitude() > b.getLongitude()) ? -1 : 1;
		
		// Horizontal and vertical distance (in meters); negative distance to move left or down
		double dlat = latdir*a.distance(new LocationData(b.getLatitude(), a.getLongitude()));
		double dlng = lngdir*a.distance(new LocationData(a.getLatitude(), b.getLongitude()));//Math.abs(a.getLongitude()+b.getLongitude());
		
		
		//// Next step (= c) ////
		
		// NHorizontal and vertical distance from 'a' to the new point (= c)
		double dnewlat = dlat/d*ms;
		double dnewlng = dlng/d*ms;
		
		/* Approximate new latitude and longitude
		 * cmp. http://stackoverflow.com/questions/2839533/adding-distance-to-a-gps-coordinate */
		double newlat = a.getLatitude() + (180/Math.PI)*(dnewlat/6378137);
		double newlng = a.getLongitude() + (180/Math.PI)*(dnewlng/6378137)/Math.cos(a.getLatitude());

		LocationData c = new LocationData(newlat, newlng);		
		
		// Check if it is beyond (swap '>' if latdir or lngdir equal -1) 
		//System.out.println(c.getLatitude() +" > "+latdir+" * "+b.getLatitude());
		//System.out.println(c.getLongitude() +" > "+lngdir+" * "+b.getLongitude());
		if (latdir*c.getLatitude() > latdir*b.getLatitude() && lngdir*c.getLongitude() > lngdir*b.getLongitude())
			{ //System.out.println("null");
			return null;}
				
		return c;
	}	

}
