package de.uni_mannheim.app;

import java.util.Random;

import javax.microedition.lcdui.Display;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import de.uni_mannheim.app.business.Status;
import de.uni_mannheim.app.gui.InCarView;
import de.uni_mannheim.app.network.NetQueue;
import de.uni_mannheim.app.network.ResponseListener;
import de.uni_mannheim.app.network.commands.GetWorkerContextCommand;
import de.uni_mannheim.app.network.commands.GetWorkerContextCommand.WorkerContext;
import de.uni_mannheim.aware.api.BooleanCondition;
import de.uni_mannheim.aware.api.Condition;
import de.uni_mannheim.aware.api.BooleanConditionListener;
import de.uni_mannheim.aware.api.Rule;
import de.uni_mannheim.aware.api.RuleListener;
import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.api.SensorFactory;
import de.uni_mannheim.aware.api.SensorListener;
import de.uni_mannheim.aware.api.custom.CustomData;
import de.uni_mannheim.aware.api.custom.CustomDataEqualsCondition;
import de.uni_mannheim.aware.api.custom.CustomDataNotEqualsCondition;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;

public class TestMIDletUI extends MIDlet {
				
		
	public TestMIDletUI() {
		
	}

	protected void destroyApp(boolean unconditional)
			throws MIDletStateChangeException {
		// TODO Auto-generated method stub

	}

	protected void pauseApp() {
		// TODO Auto-generated method stub

	}

	protected void startApp() throws MIDletStateChangeException {
	/*	InCarView v = new InCarView();
		
		v.setEstArrivalTime("3:20 pm (+10min)");
		v.setJobStartTime("3:30 pm");
		
		Display.getDisplay(this).setCurrent(v);*/
		Rule r = new Rule();
		BooleanCondition c1 = new CustomDataEqualsCondition("status", Status.ASSIGNED);
		BooleanCondition c2 = new CustomDataNotEqualsCondition("inCar", new Boolean(true));
		
		
		r.addCondition(c1);
		r.addCondition(c2);
		
		r.addRuleListener(new RuleListener() {
			public void ruleChanged(Rule rule, boolean matches) {
				System.out.println("rule changed: "+rule);
				
			}
		});
		
		c1.addConditionListener(new BooleanConditionListener() {			
			public void conditionChanged(Condition condition, boolean matches) {
				System.out.println("status con dlistener: "+condition);
			}
		});
		
		c2.addConditionListener(new BooleanConditionListener() {			
			public void conditionChanged(Condition condition, boolean matches) {
				System.out.println("incar cond listener: "+condition);
			}
		});
		
		r.setActive(true);
	
		
		try {
			SensorFactory.getImpl().getCustomSensor().addListener(new SensorListener() {			
				public void sensorDataChanged(SensorData sensorData) {
					CustomData cd = (CustomData) sensorData;
					
					System.out.println("last updated: "+cd.getLastUpdatedKey());
					System.out.println("---> NOW: "+cd);
				}
			});
		} 
		catch (UnsupportedPlatformException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		try {
			System.out.println("-------------");
			System.out.println("-------------");
			System.out.println("-------------");
			System.out.println("rule = "+r);
			
			System.out.println("-------------");
			SensorFactory.getImpl().getCustomSensor().put("status", Status.ASSIGNED);
			System.out.println("-------------");
			SensorFactory.getImpl().getCustomSensor().put("inCar", new Boolean(true));
			System.out.println("-------------");
			SensorFactory.getImpl().getCustomSensor().put("inCar", new Boolean(false));			
		} 
		catch (UnsupportedPlatformException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}

}
