package de.uni_mannheim.app.business;

import java.util.Timer;
import java.util.TimerTask;

import de.uni_mannheim.app.controllers.AbstractController;

import de.uni_mannheim.app.gui.SplashScreenView;
import de.uni_mannheim.app.periodic.ArrivalTimeEstimationThread;
import de.uni_mannheim.app.periodic.GetWorkerContextThread;
import de.uni_mannheim.app.periodic.SendLocationThread;

public class App extends AbstractController {	
	private SplashScreenView splashScreenView;
	
	public App() {
		super();

		// Init splash screen
		splashScreenView = new SplashScreenView();
		splashScreenView.setDescription("Loading ...");	
		
		show(splashScreenView);			
	}

	public void start() {
		splashScreenView.setDescription("Creating context ...");			
		ruleContext.create();
		controllerContext.create();
		viewContext.create();

		splashScreenView.setDescription("Linking context ...");			
		ruleContext.inject();
		controllerContext.inject();
		viewContext.inject();
		
		splashScreenView.setDescription("Starting context ...");			
		ruleContext.activate();
		controllerContext.activate();
		viewContext.activate();
		
		splashScreenView.setDescription("Initializing services ...");
		SendLocationThread.getInstance().start();
		ArrivalTimeEstimationThread.getInstance().start();				

		splashScreenView.setDescription("Retrieving worker context ...");
		GetWorkerContextThread.getInstance().start();
		
		/*new Timer().scheduleAtFixedRate(
			new TimerTask() { public void run() { 
				System.out.println("RULES:");
				
				System.out.println("AT CUSTOMER: "+ruleContext.getAtCustomerRule());
				System.out.println("IN CAR: " +ruleContext.getInCarDetectionRule());
				System.out.println("IN CAR DRIVING: "+ruleContext.getInCarDetectionDrivingRule());
				System.out.println("SOMEWHERE: "+ruleContext.getSomewhereRule());
				
			} }, 
			0, 5000);		*/
	}
}
