package de.uni_mannheim.app.business;

public class Status {
	public static final Status UNKNOWN = new Status(0);
	public static final Status UNASSIGNED = new Status(1);
	public static final Status PENDING = new Status(2);
	public static final Status ASSIGNED = new Status(3);
	public static final Status WORKING = new Status(4);
	
	private Integer status;
	
	public Status(int status) {
		this(new Integer(status));
	}
	
	public Status(Integer status) {
		this.status = status;
	}
	
	public Integer getStatus() {
		return status;
	}
	
	public void setStatus(Integer status) {
		this.status = status;
	}
	
	/* @Override */
	public boolean equals(Object obj) {
		if (!(obj instanceof Status))
			return false;
		
		Status status = (Status) obj;
		return status.getStatus().intValue() == getStatus().intValue();		
	}
	
	/* @Override */
	public String toString() {
		switch(status.intValue()) {
			case 1: return "UNASSIGNED";
			case 2: return "PENDING";
			case 3: return "ASSIGNED";
			case 4: return "WORKING";
			default: return "UNKNOWN";
		}
	}
}
