package de.uni_mannheim.app.context;

import de.uni_mannheim.app.controllers.AbstractController;
import de.uni_mannheim.app.controllers.AtCustomerController;
import de.uni_mannheim.app.controllers.BusinessSensorController;
import de.uni_mannheim.app.controllers.GetWorkerContextController;
import de.uni_mannheim.app.controllers.InCarController;
import de.uni_mannheim.app.controllers.InCarDrivingController;
import de.uni_mannheim.app.controllers.JobAssignedController;
import de.uni_mannheim.app.controllers.JobDetailsController;
import de.uni_mannheim.app.controllers.JobPendingController;
import de.uni_mannheim.app.controllers.LateArrivalController;
import de.uni_mannheim.app.controllers.LocationSensorController;
import de.uni_mannheim.app.controllers.MessagePopupController;
import de.uni_mannheim.app.controllers.NoJobController;
import de.uni_mannheim.app.controllers.UpdateTimeController;
import de.uni_mannheim.app.controllers.WorkingController;
import de.uni_mannheim.app.controllers.YesNoMessageController;
import de.uni_mannheim.app.network.commands.GetWorkerContextCommand;
import de.uni_mannheim.aware.api.SensorListener;


public class ControllerContext implements Context {
	
	private static ControllerContext instance;
	
	private AtCustomerController atCustomerController;
	private BusinessSensorController businessSensorController;
	private GetWorkerContextController getWorkerContextController;
	private InCarDrivingController inCarDrivingController;
	private InCarController inCarController; 
	private JobAssignedController jobAssignedController;
	private JobDetailsController jobDetailsController;
	private JobPendingController jobPendingController;
	private LateArrivalController lateArrivalController;
	private LocationSensorController locationSensorController;
	private MessagePopupController messagePopupController;
	private NoJobController noJobController;
	private UpdateTimeController updateTimeController;	
	private WorkingController workingController;
	private YesNoMessageController yesNoMessageController;
	
	private ControllerContext() {
		// Fressen!
	}
	
	public static ControllerContext getInstance() {
		if (instance == null)
			instance = new ControllerContext();
		
		return instance;
	}

	public void create() {
		atCustomerController = new AtCustomerController();
		businessSensorController = new BusinessSensorController();
		getWorkerContextController = new GetWorkerContextController();
		inCarDrivingController = new InCarDrivingController();
		inCarController = new InCarController();
		jobAssignedController = new JobAssignedController();
		jobDetailsController = new JobDetailsController();
		jobPendingController = new JobPendingController();
		lateArrivalController = new LateArrivalController();
		locationSensorController = new LocationSensorController();
		messagePopupController = new MessagePopupController();
		noJobController = new NoJobController();
		updateTimeController = new UpdateTimeController();
		workingController = new WorkingController();
		yesNoMessageController = new YesNoMessageController();
	}
	
	public void inject() {
		
	}
	
	public void activate() {
		
	}

	public AtCustomerController getAtCustomerController() {
		return atCustomerController;
	}

	public void setAtCustomerController(AtCustomerController atCustomerController) {
		this.atCustomerController = atCustomerController;
	}

	public BusinessSensorController getBusinessSensorController() {
		return businessSensorController;
	}

	public void setBusinessSensorController(BusinessSensorController businessSensorController) {
		this.businessSensorController = businessSensorController;
	}	
	
	public void setGetWorkerContextController(GetWorkerContextController getWorkerContextController) {
		this.getWorkerContextController = getWorkerContextController;
	}

	public GetWorkerContextController getGetWorkerContextController() {
		return getWorkerContextController;
	}
	
	public InCarDrivingController getInCarDrivingController() {
		return inCarDrivingController;
	}

	public void setInCarDrivingController(
			InCarDrivingController inCarDrivingController) {
		this.inCarDrivingController = inCarDrivingController;
	}

	public InCarController getInCarController() {
		return inCarController;
	}

	public void setInCarController(InCarController inCarController) {
		this.inCarController = inCarController;
	}

	public JobAssignedController getJobAssignedController() {
		return jobAssignedController;
	}

	public void setJobAssignedController(JobAssignedController jobAssignedController) {
		this.jobAssignedController = jobAssignedController;
	}

	public JobDetailsController getJobDetailsController() {
		return jobDetailsController;
	}

	public void setJobDetailsController(JobDetailsController jobDetailsController) {
		this.jobDetailsController = jobDetailsController;
	}

	public JobPendingController getJobPendingController() {
		return jobPendingController;
	}

	public void setJobPendingController(JobPendingController jobPendingController) {
		this.jobPendingController = jobPendingController;
	}

	public LateArrivalController getLateArrivalController() {
		return lateArrivalController;
	}

	public void setLateArrivalController(LateArrivalController lateArrivalController) {
		this.lateArrivalController = lateArrivalController;
	}

	public LocationSensorController getLocationSensorController() {
		return locationSensorController;
	}
	
	public void setLocationSensorController(LocationSensorController locationSensorController) {
		this.locationSensorController = locationSensorController;
	}

	public MessagePopupController getMessagePopupController() {
		return messagePopupController;
	}

	public void setMessagePopupController(MessagePopupController messagePopupController) {
		this.messagePopupController = messagePopupController;
	}

	public UpdateTimeController getUpdateTimeController() {
		return updateTimeController;
	}

	public void setUpdateTimeController(UpdateTimeController updateTimeController) {
		this.updateTimeController = updateTimeController;
	}

	public WorkingController getWorkingController() {
		return workingController;
	}

	public void setWorkingController(WorkingController workingController) {
		this.workingController = workingController;
	}

	public YesNoMessageController getYesNoMessageController() {
		return yesNoMessageController;
	}

	public void setYesNoMessageController(
			YesNoMessageController yesNoMessageController) {
		this.yesNoMessageController = yesNoMessageController;
	}

	public NoJobController getNoJobController() {
		return noJobController;
	}

	public void setNoJobController(NoJobController noJobController) {
		this.noJobController = noJobController;
	}



}
