package de.uni_mannheim.app.controllers;

import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.midlet.MIDlet;

import org.kalmeo.kuix.core.Kuix;
import org.kalmeo.util.frame.Frame;

import com.sun.perseus.util.RunnableQueue.VoidQueueHandler;

import de.uni_mannheim.app.FieldApp;
import de.uni_mannheim.app.context.ControllerContext;
import de.uni_mannheim.app.context.RuleContext;
import de.uni_mannheim.app.context.ViewContext;
import de.uni_mannheim.app.context.WorkerContext;
import de.uni_mannheim.app.gui.AtCustomerView;
import de.uni_mannheim.app.gui.InCarDrivingView;
import de.uni_mannheim.app.gui.InCarView;
import de.uni_mannheim.app.gui.JobAssignedView;
import de.uni_mannheim.app.gui.JobDetailsView;
import de.uni_mannheim.app.gui.JobPendingView;
import de.uni_mannheim.app.gui.MessagePopupAlert;
import de.uni_mannheim.app.gui.SplashScreenView;
import de.uni_mannheim.app.gui.UpdateTimeView;
import de.uni_mannheim.app.gui.WorkingView;
import de.uni_mannheim.app.network.NetQueue;
import de.uni_mannheim.aware.api.Condition;
import de.uni_mannheim.aware.api.Rule;
import de.uni_mannheim.aware.impl.CommonCustomSensor;

public abstract class AbstractController implements Controller {
	protected WorkerContext workerContext;
	protected RuleContext ruleContext;
	protected ControllerContext controllerContext;
	protected ViewContext viewContext;
	protected NetQueue net;
	
	public AbstractController() {
		System.out.println(getClass().getName());
		// Main MIDlet, Worker Context, Networking, ...
		this.workerContext = WorkerContext.getInstance();
		this.ruleContext = RuleContext.getInstance();
		this.controllerContext = ControllerContext.getInstance();
		this.viewContext = ViewContext.getInstance();
		this.net = NetQueue.getInstance();  
	}
	
	public synchronized void show(Frame view) {
		if (viewContext.getBackView() == null) {
			System.out.println("[AbstractController] Showing "+view);
			
			Kuix.getFrameHandler().removeAllFrames();
			Kuix.getFrameHandler().pushFrame(view);			

			viewContext.setCurrentView(view);
		}  
		
		// Dialog is currently being displayed! Don't show, only change back-view
		else {
			System.out.println("[AbstractController] NOT SHOWING view. Instead, just changing BACK VIEW");
			viewContext.setBackView(view);
		}
	}
	
	public synchronized void show(Frame view, Frame backView) {
		System.out.println("[AbstractController] Showing "+view+", setting back view to "+backView);

		viewContext.setBackView(backView);
		
		Kuix.getFrameHandler().removeAllFrames();
		Kuix.getFrameHandler().pushFrame(view);						
	}
	
	public synchronized void back() {
		System.out.println("[AbstractController] Going back to '"+viewContext.getBackView()+"'");

		Kuix.getFrameHandler().removeAllFrames();
		Kuix.getFrameHandler().pushFrame(viewContext.getBackView());
		
		viewContext.setBackView(null);			
	}
		
	/* @Override */
	public boolean onMessage(Object o, Object[] os) {
		System.out.println("YOU NEED TO OVERRIDE THIS IF YOU WAN SOMETHING TO HAPPEN");
		return false;
	}
}
