package de.uni_mannheim.app.controllers;

import java.util.Date;

import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemCommandListener;
import javax.microedition.lcdui.StringItem;

import de.uni_mannheim.app.business.Status;
import de.uni_mannheim.app.gui.AtCustomerView;
import de.uni_mannheim.app.network.commands.StartJobCommand;
import de.uni_mannheim.app.periodic.ArrivalTimeEstimationThread;
import de.uni_mannheim.aware.api.Rule;
import de.uni_mannheim.aware.api.RuleListener;

public class AtCustomerController
	extends AbstractController
	implements ItemCommandListener, RuleListener {
	
	public void ruleChanged(Rule rule, boolean matches) {
		System.out.println(rule);
		if (matches) {
			System.out.println("[AtCustomerController] We are near the customer.");
			System.out.println("[AtCustomerController] Deactivating arrival time estimation and late arrival rule.");
			
			//ArrivalTimeEstimationThread.getInstance().stop();
			ruleContext.getLateArrivalRule().setActive(false);
			
			show(viewContext.getAtCustomerView());
		}
		
	}

	public void commandAction(Command c, Item i) {
	}

	/* @Override */
	public boolean onMessage(Object o, Object[] os) {
		if ("start".equals(o)) {			
			// Update client + server side
			synchronized (workerContext) {
				workerContext.getCurrentJob().setActualStartTime(new Date());
				workerContext.setStatus(Status.WORKING);
			}
			
			net.send(new StartJobCommand(workerContext.getWorkerId(), workerContext.getCurrentJob()));								

			// Change status (view adjusted by rules)
			ruleContext.getBusinessSensor().put("status", workerContext.getStatus());
			return true;
		}
		
		else if ("details".equals(o)) {			
			show(viewContext.getJobDetailsView(), viewContext.getAtCustomerView());
			return true;
		}
		
		return false;
	}
}
