package de.uni_mannheim.app.controllers;

import java.util.Calendar;

import javax.microedition.lcdui.Display;

import de.uni_mannheim.app.business.Status;
import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.api.SensorListener;
import de.uni_mannheim.aware.api.custom.CustomData;
import de.uni_mannheim.aware.util.DateUtil;
import de.uni_mannheim.aware.util.StringUtil;

public class BusinessSensorController extends AbstractController implements SensorListener {

	public void sensorDataChanged(SensorData sensorData) {
		CustomData data = (CustomData) sensorData;
		String lastUpdatedKey = data.getLastUpdatedKey();
		
		if ("status".equals(lastUpdatedKey)) {			
			System.out.println("[BusinessSensorController] Status changed: "+sensorData);

			Status newStatus = (Status) data.get(lastUpdatedKey);
			
			if (newStatus.equals(Status.PENDING)) {
				System.out.println("[BusinessSensorController] Job pending. Displaying PENDING view.");				
				show(viewContext.getJobPendingView());
			}
			
			else if (newStatus.equals(Status.WORKING)) {
				System.out.println("[BusinessSensorController] Working state detected. Displaying WORKING view.");
				show(viewContext.getWorkingView());			
			}
			
			else if (newStatus.equals(Status.UNASSIGNED)) {
				System.out.println("unassigned --> hiding screen.");
				show(viewContext.getNoJobView());
			}
			
			else if (newStatus.equals(Status.ASSIGNED)) {
				System.out.println("[BusinessSensorController] Job assigned. Doing nothing (handled by other rules).");
				//Display.getDisplay(midlet).setCurrent(null);				
			}
		}
		
		else if ("arrivalTimeEstimation".equals(lastUpdatedKey)) {
			System.out.println("[BusinessSensorController] New time estimation found. Updating views.");
			
			// Update views
			//String estArrivalTime = workerContext.getEstimatedArrivalTime().toString();
			
			long diff = (workerContext.getEstimatedArrivalTime().getTime()
				- workerContext.getCurrentJob().getEstimatedStartTime().getTime() + 30000)/60000;
			
			// ---
			String timeString = DateUtil.dateToTimeString(workerContext.getEstimatedArrivalTime());
			
			String estArrivalTime = timeString +" (" +  (diff < 1 ? "on-time ": "delayed +") + diff + " min)";
			
			viewContext.getJobAssignedView().setArrivalTime(estArrivalTime);
			viewContext.getInCarView().setArrivalTime(estArrivalTime);
			viewContext.getInCarDrivingView().setArrivalTime(estArrivalTime);			
		}
	}
}
