package de.uni_mannheim.app.controllers;

import de.uni_mannheim.app.business.Job;
import de.uni_mannheim.app.business.Status;
import de.uni_mannheim.app.network.ResponseListener;
import de.uni_mannheim.app.network.commands.GetWorkerContextCommand.WorkerContext;
import de.uni_mannheim.app.periodic.GetWorkerContextThread;
import de.uni_mannheim.aware.api.Rule;
import de.uni_mannheim.aware.api.location.LocationData;
import de.uni_mannheim.aware.api.location.LocationNearCondition;
import de.uni_mannheim.aware.impl.SensorNotAvailableException;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;

public class GetWorkerContextController extends AbstractController implements ResponseListener {

	public boolean processResponse(Object object) {
		WorkerContext resp = (WorkerContext) object;
		
		// Update local model
		synchronized (workerContext) {
			try {
				if (workerContext.getCurrentJob() == null /*|| !context.getCurrentJob().equals(resp.getCurrentJob())*/) {
					System.out.println("[GetWorkerContextController] New current job received.");
					
					
					//Job j = (resp.getStatus() == Status.PENDING) ? resp.getNextJob() : resp.getCurrentJob();
					// @Lars Bugfix: Current job has to be set to the next job and not the current job again
					workerContext.setCurrentJob(resp.getCurrentJob());
					workerContext.setNextJob(resp.getNextJob());
									
//					if (workerContext.getStatus() == null /*|| !context.getStatus().equals(resp.getStatus())*/)
						workerContext.setStatus(resp.getStatus());							
					
		
					// Update views
					System.out.println(resp.getCurrentJob() + " -- next: "+resp.getNextJob());
					
					if (resp.getStatus().equals(Status.PENDING)) {
						viewContext.updateJobDetails(resp.getNextJob());						
					}
					
					else if (resp.getStatus().equals(Status.ASSIGNED)) {
						viewContext.updateJobDetails(resp.getCurrentJob());
						ruleContext.updateAtCustomerRule(resp.getCurrentJob());
						ruleContext.getLateArrivalRule().setActive(true);
					}
					
				}
							
				//if (context.getNextJob() == null || !context.getNextJob().equals(resp.getNextJob()))
				// always update:
				//workerContext.setNextJob(resp.getNextJob());

			}
			catch (Exception ee) {
				System.out.println("eoäär:"+ee);
				ee.printStackTrace();
			}
		}
		
		// Change UI according to status (event based)
		System.out.println(workerContext + " "+ruleContext.getBusinessSensor());
		ruleContext.getBusinessSensor().put("status", workerContext.getStatus());
		
		
		
		// stop myself
		//GetWorkerContextThread.getInstance().stop();
		
		
		return true;
	}

}
