package de.uni_mannheim.app.controllers;

import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemCommandListener;

import de.uni_mannheim.app.gui.InCarView;
import de.uni_mannheim.app.gui.JobPendingView;
import de.uni_mannheim.aware.api.Rule;
import de.uni_mannheim.aware.api.RuleListener;
import de.uni_mannheim.aware.api.location.LocationSensor;
import de.uni_mannheim.aware.impl.emu.EmulatedLocationPathSensor;

public class InCarController 
	extends AbstractController 
	implements RuleListener {
	
	
	public InCarController() {
		// Fressen.
	}
	
	public void ruleChanged(Rule rule, boolean matches) {
		System.out.println("[InCarController] Matches?? "+rule);
		if (!matches)
			return;
		
		System.out.println("[InCarController] In car detected. Rule matches: "+rule);
		System.out.println("[InCarController] ISwitching to IN CAR view.");
		
		show(viewContext.getInCarView());		
	}

	public boolean onMessage(Object o, Object[] os) {
		if ("start".equals(o)) {
			System.out.println("[InCarController] Start navigation (virtual location sensor!)");
			
			LocationSensor ls = ruleContext.getLocationSensor();
			
			if (ls instanceof EmulatedLocationPathSensor)
				((EmulatedLocationPathSensor) ls).setEnabled(true);

			return true;
		}
		
		else if ("details".equals(o)) {
			show(viewContext.getJobDetailsView(), viewContext.getInCarView());
			return true;
		}
		
		return false;

	}
	
}
