package de.uni_mannheim.app.controllers;

import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemCommandListener;

import de.uni_mannheim.app.business.Job;
import de.uni_mannheim.app.business.Status;
import de.uni_mannheim.app.gui.AtCustomerView;
import de.uni_mannheim.app.gui.JobDetailsView;
import de.uni_mannheim.app.gui.JobPendingView;
import de.uni_mannheim.app.network.commands.AcceptJobCommand;
import de.uni_mannheim.app.periodic.ArrivalTimeEstimationThread;

public class JobPendingController extends AbstractController {
	/* @Override */
	public boolean onMessage(Object o, Object[] os) {
		System.out.println("[JobPendingController] Message '"+o+"'");
		
		if ("accept".equals(o)) {
			// Update client side 
			synchronized (workerContext) {
				workerContext.setCurrentJob(workerContext.getNextJob());
				workerContext.setNextJob(null);	
				workerContext.setStatus(Status.ASSIGNED);
			}
			
			synchronized (ruleContext) {
				System.out.println("UPDATING customer rule: "+workerContext.getCurrentJob());
				ruleContext.updateAtCustomerRule(workerContext.getCurrentJob());
				ruleContext.getLateArrivalRule().setActive(true);
			}
			
			// Update server side
			System.out.println("[JobPendingController] Sending accept command ...");
			net.send(new AcceptJobCommand(workerContext.getWorkerId(), workerContext.getCurrentJob()));								

			// Change status
			System.out.println("[JobPendingController] Setting business-sensor STATUS to "+workerContext.getStatus());
			ruleContext.getBusinessSensor().put("status", workerContext.getStatus());
			
			
			// Update views
			Job j = workerContext.getCurrentJob();									
			viewContext.updateJobDetails(j);			
			
			return true;
		}

		else if ("details".equals(o)) {		
			viewContext.updateJobDetails(workerContext.getNextJob());
			/*JobDetailsView v = viewContext.getJobDetailsView();
			
			v.setJob(workerContext.getCurrentJob().getTitle());
			v.setDescription(workerContext.getCurrentJob().getSummary());
			v.setCustomer(workerContext.getCurrentJob().getCustomer());
			v.setLocation(workerContext.getCurrentJob().getAddress());*/
			
			show(viewContext.getJobDetailsView(), viewContext.getJobPendingView());
			return true;
		}
		
		else if ("decline".equals(o)) {
			viewContext.getMessagePopupView().setMessage("You're fired!");
			show(viewContext.getMessagePopupView(), viewContext.getJobPendingView());
			return true;			
		}
		
		return false;
	}
}
