package de.uni_mannheim.app.controllers;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;

import de.uni_mannheim.app.business.Status;
import de.uni_mannheim.app.gui.WorkingView;
import de.uni_mannheim.app.network.commands.FinishJobCommand;

public class WorkingController extends AbstractController {
	/* @Override */
	public boolean onMessage(Object o, Object[] os) {
		if ("record".equals(o)) {
			// TODO ?!?! record spare parts
			System.out.println("DO NOTHING ?!");
			return true;
		}
		
		else if ("updateTime".equals(o)) {
			show(viewContext.getUpdateTimeView());
			return true;
		}
		
		else if ("details".equals(o)) {
			show(viewContext.getJobDetailsView(), viewContext.getWorkingView());		
			return true;
		}				
		
		else if ("finish".equals(o)) {					
			// Update local + server model
			workerContext.getCurrentJob().setActualDuration(
				(int) (System.currentTimeMillis() - workerContext.getCurrentJob().getActualStartTime().getTime()));
			
			net.send(new FinishJobCommand(workerContext.getWorkerId(), workerContext.getCurrentJob()));

			// Update local model
			// TODO: synchronize this!
			synchronized (workerContext) {
				workerContext.setCurrentJob(workerContext.getNextJob());
				workerContext.setNextJob(null);					
				workerContext.setStatus((workerContext.getCurrentJob() == null) ? Status.UNASSIGNED : Status.PENDING);						
			}					
			
			// Switch UI
			ruleContext.getBusinessSensor().put("status", workerContext.getStatus());
			return true;
		}
		
		return false;
	}
}
