package de.uni_mannheim.app.gui;

import java.util.Hashtable;

import org.kalmeo.kuix.core.Kuix;
import org.kalmeo.kuix.core.model.DataProvider;
import org.kalmeo.kuix.widget.Screen;
import org.kalmeo.util.frame.Frame;

import de.uni_mannheim.app.controllers.Controller;

public abstract class AbstractView implements Frame {
	protected String viewName;
	protected DynamicDataProvider dataProvider;
	protected Screen screen;
	protected Controller controller;
	   
	public AbstractView(String viewName) {
		this.viewName = viewName;
		this.dataProvider = new DynamicDataProvider();
		this.screen = null;
		//this.screen = Kuix.loadScreen(viewName, dataProvider);
	}
	
	public void onAdded() {
        screen = Kuix.loadScreen(viewName, dataProvider);
        screen.setCurrent();
	}

	public void onRemoved() {
		screen.cleanUp();
		screen = null;		
	}	
	
	public void setController(Controller controller) {
		this.controller = controller;
	}
	
	/* @Override */
	public boolean onMessage(Object o, Object[] os) {
		if (controller == null) {
			System.out.println("[AbstractView] No controller!"); return false; }
		
        return controller.onMessage(o, os);
    }
	
	public class DynamicDataProvider extends DataProvider {
	    private Hashtable data;

	    public DynamicDataProvider() {
	    	this.data = new Hashtable();
	    }
	    
	    public void setProperty(String property, Object value) {
	    	data.put(property, value);
	    	dispatchUpdateEvent(property);
	    }
	    
	    public Object getProperty(String property) {
	    	return data.get(property);
	    }
	    
	    /* @Override */
	    protected Object getUserDefinedValue(String property) {
	    	return data.get(property);
	    }

	}	
}
