package de.uni_mannheim.app.network;



	

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;

import org.json.me.JSONException;
import org.json.me.JSONObject;

/**
 * @author Philipp Heckel, Moritz Wächter
 */
public class Sender { 
	public JSONObject post(String url, JSONObject content) throws IOException {
		return send(url, content, HttpConnection.POST);
	}

	public JSONObject get(String url) throws IOException {
		return send(url, null, HttpConnection.GET);
	}	

	/**
	 * 
	 * @see http://www.devx.com/getHelpOn/10MinuteSolution/16646/0/page/3
	 * @param content
	 * @param uri
	 * @return
	 * @throws IOException
	 * @throws JSONException
	 */
	public JSONObject send(String url, JSONObject content, String method) throws IOException {
		System.out.println("[Sender] Sending: "+method+" "+url);
		if (content != null) System.out.println("[Sender] --> Content/Data: "+content.toString());		
		
		// Open connection
		HttpConnection http = (HttpConnection) Connector.open(url, Connector.READ_WRITE);
		
		http.setRequestMethod(method);
		http.setRequestProperty("Content-Type", "application/json");		
		
		// Send request (if body given)
		if (content != null) {
			// Prepare request (create JSON) 
			DataOutputStream dos = http.openDataOutputStream();  
			byte[] byteRequest = content.toString().getBytes(); 
			
			// Write!
			for(int i = 0; i<byteRequest.length; i++) 
			       dos.writeByte(byteRequest[i]);
	
			//dos.flush(); //Including this line may produce undesired results on certain devices
			/* If you call c.flush(), some devices will send the request in HTTP 1.1 "chunked" encoding by adding a "Transfer-encoding: chunked" header to the request and writing the size of each block of data in hexadecimal form as a text line before the data bytes themselves. This is repeated for any number of blocks you send, usually demarcated by calls to flush().
			If you have a HTTP 1.1-compliant Web server this should be transparent to your server side scripts, but if you do not, you will either want to avoid calling flush() (though some devices may still chunk for you automatically) or write some HTTP 1.1 chunk handling code in your server scripts. All you will need to do in the latter case is read the first text line of the response, extract the size from it (i.e. "C\r\n" where C means 12 bytes of chunk follow), and then read 12 bytes of response data. Then read another line to see if there is another chunk size, and repeat until stream is closed or your script has all the data it needs. See the HTTP 1.1 specification for more details.  */
			
			try { dos.close(); }
			catch (IOException e) { /* Who cares! */ }
		}
		
		// Receive answer
		StringBuffer responseBody = new StringBuffer();		
		InputStream dis = http.openInputStream();
		
		int ch;  
		while ((ch = dis.read()) != -1)
			responseBody.append((char) ch);

		System.out.println("[Sender] --> Response: " + responseBody.toString());

		// Return response
		JSONObject response = null;
		
		try { response = new JSONObject(responseBody.toString()); }
		catch (JSONException e) { /* Bad luck! Return null */ }
		
		// Close connection
		try { dis.close(); http.close(); }
		catch (IOException e) { /* Who cares! */ }		 

		return response;		
	}
}
