package de.uni_mannheim.app.periodic;

import java.util.Timer;
import java.util.TimerTask;

import de.uni_mannheim.app.controllers.AbstractController;
import de.uni_mannheim.app.controllers.GetWorkerContextController;
import de.uni_mannheim.app.network.NetQueue;
import de.uni_mannheim.app.network.commands.GetWorkerContextCommand;
import de.uni_mannheim.aware.api.Config;
import de.uni_mannheim.aware.api.SensorFactory;
import de.uni_mannheim.aware.api.location.LocationNearCondition;
import de.uni_mannheim.aware.api.location.LocationSensor;
import de.uni_mannheim.aware.impl.CommonSensor;
import de.uni_mannheim.aware.impl.SensorNotAvailableException;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;

public class GetWorkerContextThread extends AbstractController {	
	public static final int INTERVAL = 15000;
	private static GetWorkerContextThread instance;
	
	private Timer timer;
	
	private GetWorkerContextThread() {		
		this.timer = null;
	}
	
	public static GetWorkerContextThread getInstance() {
		if (instance == null)
			instance = new GetWorkerContextThread();
		
		return instance;
	}
	
	public synchronized void start() {
		timer = new Timer();
		
		timer.scheduleAtFixedRate(
			new TimerTask() { public void run() { runTimerTask(); } }, 
			0, INTERVAL);		
	}
	
	public synchronized void stop() {
		timer.cancel();
		timer = null;
	}
	
	private void runTimerTask() {
		try {
		System.out.println("[GetJobContextSensor] Retrieving worker context "+ workerContext.getWorkerId()+"...");
		
		net.send(
			new GetWorkerContextCommand(workerContext.getWorkerId()), 
			controllerContext.getGetWorkerContextController());
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}
