package de.uni_mannheim.aware.api;

/**
 * A sensor represents current up-to-date device data. Every 
 * implementation must inherit this interface, and fire an event
 * when it's data has changed.
 * 
 * <p>Event listeners must use the {@link SensorListener} interface.
 * 
 * @author Philipp Heckel, Lars Bakker
 */
public interface Sensor {
/*	void updateConditions();
	
	void setSensorData(SensorData sensorData);
	SensorData getSensorData();*/
	
	void addListener(SensorListener listener);
	void removeListener(SensorListener listener);
}
