package de.uni_mannheim.aware.api.battery;

import de.uni_mannheim.aware.api.SensorData;

/**
 * 
 * @author Philipp Heckel
 */
public class BatteryData extends SensorData {
	public static final byte POWER_STATUS_UNKNOWN = 0;
	public static final byte POWERED_BY_BATTERY = 1;
	public static final byte BATTERY_CONNECTED_BUT_EXTERNALLY_POWERED = 2;
	public static final byte NO_BATTERY_CONNECTED = 3;
	public static final byte POWER_FAULT = 4;
	
	private byte chargerStatus;
	private int chargeLevel;
	
	public BatteryData() {
		this(POWER_STATUS_UNKNOWN, -1);
	}
	
	public BatteryData(byte chargerStatus, int chargeLevel) {
		this.chargerStatus = chargerStatus;
		this.chargeLevel = chargeLevel;
	}
	
	public void setChargerStatus(byte chargerStatus) {
		this.chargerStatus = chargerStatus;
	}
	
	public byte getChargerStatus() {
		return chargerStatus;
	}
	
	public String getChargerStatusString() {
		switch (chargerStatus) {
			case POWER_STATUS_UNKNOWN: return "POWER_STATUS_UNKNOWN";
			case POWERED_BY_BATTERY: return "POWERED_BY_BATTERY";
			case BATTERY_CONNECTED_BUT_EXTERNALLY_POWERED: return "BATTERY_CONNECTED_BUT_EXTERNALLY_POWERED";
			case NO_BATTERY_CONNECTED: return "NO_BATTERY_CONNECTED";
			case POWER_FAULT: return "POWER_FAULT";
			default: return "INVALID STATUS";
		}
	}

	public void setChargeLevel(int chargeLevel) {
		this.chargeLevel = chargeLevel;
	}
	
	public int getChargeLevel() {
		return chargeLevel;
	}
	
	/* @Override */
	public SensorData clone() {
		// TODO Auto-generated method stub
		return null;
	}
	
	/* @Override */
	public boolean equals(Object obj) {
		if (! (obj instanceof BatteryData))
			return false;
		
		BatteryData aStatus = (BatteryData) obj;
		return (aStatus.getChargeLevel() == getChargeLevel()
				&& aStatus.getChargerStatus() == getChargerStatus());
	}
	
	/* @Override */
	public String toString() {
		return "{rx="+getChargeLevel()+", status="+getChargerStatus()+"/"+getChargerStatusString()+"}";
	}
}

