package de.uni_mannheim.aware.api.bluetooth;

import java.util.Enumeration;
import java.util.Vector;

import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.util.StringUtil;
import de.uni_mannheim.aware.util.VectorUtil;

/**
 * 
 * @author Philipp Heckel
 */
public class BluetoothData extends SensorData {
	private Vector devices;
	private Vector discovered;
	private Vector vanished;
	
	public BluetoothData() {
		devices = new Vector();
		discovered = new Vector();
		vanished = new Vector();
	}
	
	public Vector getDevices() {
		return devices;
	}
	
	public void setDevices(Vector devices) {
		this.devices = devices;
	}
	
	public Vector getDiscovered() {
		return discovered;
	}
	
	public void setDiscovered(Vector discovered) {
		this.discovered = discovered;
	}
	
	public Vector getVanished() {
		return vanished;
	}
	
	public void setVanished(Vector vanished) {
		this.vanished = vanished;
	}
	
	/* @Override */
	public SensorData clone() {
		BluetoothData clone = new BluetoothData();
		
		clone.setDevices(VectorUtil.clone(getDevices()));
		clone.setDiscovered(VectorUtil.clone(getDiscovered()));
		clone.setVanished(VectorUtil.clone(getVanished()));
		
		return clone;
	}
	
	/* @Override */
	public boolean equals(Object obj) {
		if (! (obj instanceof BluetoothData))
			return false;
		
		BluetoothData data = (BluetoothData) obj;
				
		// Compare device lists
		return VectorUtil.equalElements(getDevices(), data.getDevices())
			&& VectorUtil.equalElements(getDiscovered(), data.getDiscovered())
			&& VectorUtil.equalElements(getVanished(), data.getVanished());
	}
	
	/* @Override */
	public String toString() {
		return "{devices:["+StringUtil.join(",", VectorUtil.toArray(getDevices()))+"],"
			+ "discovered:["+StringUtil.join(",", VectorUtil.toArray(getDiscovered()))+"],"
			+ "vanished:["+StringUtil.join(",", VectorUtil.toArray(getVanished()))+"]}";
	}
}
