package de.uni_mannheim.aware.api.bluetooth;

/**
 * 
 * @author Philipp Heckel
 */
public class BluetoothDevice {
	private String address;
	private String friendlyName;
	
	public BluetoothDevice()  {
		this("", "");
	}
	
	public BluetoothDevice(String address) {
		this(address, "");
	}
	
	public BluetoothDevice(String address, String friendlyName) {
		this.address = address;
		this.friendlyName = friendlyName;
	}
	
	public String getAddress() {
		return address;
	}
	
	public void setAddress(String address) {
		this.address = address;
	}
	
	public String getFriendlyName() {
		return friendlyName;
	}
	
	public void setFriendlyName(String friendlyName) {
		this.friendlyName = friendlyName;
	}
	
	/* @Override */
	public boolean equals(Object obj) {
		if (! (obj instanceof BluetoothDevice))
			return false;
		
		return getAddress().toLowerCase().equals( 
				((BluetoothDevice) obj).getAddress().toLowerCase() );
	}
	
	/* @Override */
	public String toString() {
		if ("".equals(getFriendlyName()))
				return "{address:\""+getAddress().toLowerCase()+"\"}";
		else
			return "{address:\""+getAddress().toLowerCase()+"\",friendlyName:\""+getFriendlyName()+"\"}";
	}
}
