package de.uni_mannheim.aware.api.bluetooth;

import de.uni_mannheim.aware.impl.SensorNotAvailableException;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;

public class BluetoothDeviceAvailableCondition extends BluetoothCondition {
	private BluetoothDevice device;
	
	public BluetoothDeviceAvailableCondition(BluetoothDevice device)
			throws UnsupportedPlatformException, SensorNotAvailableException {
		
		super();
		this.device = device;
	}

	public BluetoothDeviceAvailableCondition(String deviceAddress) 
		throws UnsupportedPlatformException, SensorNotAvailableException {
		
		this(new BluetoothDevice(deviceAddress));
	}

	protected boolean matches(BluetoothData currentBluetoothData) {
		return currentBluetoothData.getDevices().contains(device);
	}
	
	public String toString() {
		return "{expr:\"BT device "+device.getAddress()+" exist\",matches:"+isConditionMet()+"}";
	}
}
