package de.uni_mannheim.aware.api.custom;

import java.util.Enumeration;
import java.util.Hashtable;

import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.api.time.TimeData;
import de.uni_mannheim.aware.impl.CommonCustomSensor;

public class CustomData extends SensorData {
	private Hashtable map;
	private String lastUpdatedKey;

	public CustomData() {
		map = new Hashtable();		
	}
	
	/* @Override */
	public synchronized void put(String name, Object value) {
		map.put(name, value);
		lastUpdatedKey = name;
	}
	
	/* @Override */
	public synchronized Object get(String name) {
		return map.get(name);
	}
	
	public String getLastUpdatedKey() {
		return lastUpdatedKey;
	}

	/* @Override */
	public SensorData clone() {
		CustomData clone = new CustomData();
		
		for (Enumeration e = map.keys(); e.hasMoreElements(); ) {
			String key = (String) e.nextElement();
			clone.put(key, map.get(key));
		}
		
		return clone;			
	}

	/* @Override */
	public boolean equals(Object obj) {
		if (! (obj instanceof CustomData))
			return false;
		
		//System.out.println("OBJ: "+((CustomData) obj)+" -- THIS: "+this);
		return ((CustomData) obj).map.equals(map);
	}
	
	/* @Override */
	public String toString() {
		String result = "{map:{";
		
		for (Enumeration e = map.keys(); e.hasMoreElements(); ) {
			String key = (String) e.nextElement();
			result += key+":'"+map.get(key)+"'";
			
			if (e.hasMoreElements())
				result += ",";
		}		
		
		return result+"}}";
	}
}
