package de.uni_mannheim.aware.api.custom;

import de.uni_mannheim.aware.api.BooleanCondition;
import de.uni_mannheim.aware.api.Sensor;
import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.api.bluetooth.BluetoothData;
import de.uni_mannheim.aware.impl.CommonCustomSensor;

public abstract class CustomDataCondition extends BooleanCondition {
	private String name;
	
	public CustomDataCondition(String name) {
		super(CommonCustomSensor.getInstance());
		
		this.name = name;
	}

	public CustomData getCustomData() {
		return (CustomData) getSensorData();
	}
	
	public String getName() {
		return name;
	}
	
	/* @Override */
	public void sensorDataChanged(SensorData sensorData) {
		//System.out.println("Condition ("+this+"): sensor data changed: "+sensorData);
		if (! (sensorData instanceof CustomData))
			return;
				
		// Update data
		CustomData data = (CustomData) sensorData.clone();

		if (data.equals(getCustomData())) {
			//System.out.println("[CustomDataCondition]: no change; return!");
			return; }

		// IMPORTANT: Only update relevant data
	/*	System.out.println("comparing "+data+" WITH "+getCustomData());
		if (getCustomData() != null && !data.getName().equals(getCustomData().getName()))
			return;
		
		System.out.println("[CustomDataCondition] Sensor data changed: "+sensorData);
*/		setSensorData(data);

		// Check changes
		boolean conditionMatches = matches(data);
		//System.out.println("matches = "+conditionMatches);
		// Notify if changed
		if (isConditionMet() != conditionMatches) {
			//System.out.println("fire!");
			setConditionMet(conditionMatches);	
			fireConditionChangedEvent();
		}		
	}
	
	protected abstract boolean matches(CustomData currentBusinessData);
}
