package de.uni_mannheim.aware.api.custom;

public class CustomDataNotEqualsCondition extends CustomDataCondition {
	private Object value;
	
	public CustomDataNotEqualsCondition(String name, Object value) {
		super(name);
		this.value = value;
	}
	
	public Object getValue() {
		return value;
	}
	
	/* @Override */
	protected boolean matches(CustomData currentBusinessData) {		
		Object currentValue = currentBusinessData.get(getName());
		
		//System.out.println("matches??? "+getName()+" ---sensordata="+currentValue+ " !=  conditiondata="+getValue());
		if (currentValue == null && value != null)
			return true;
		
		return (currentValue != null && !currentValue.equals(value));
	}
	
	/* @Override */
	public String toString() {
		return "{expr:\"sensor('"+getName()+"') != '"+getValue()+"' ??\",matches:"+isConditionMet()+"}";
	}

}
