package de.uni_mannheim.aware.api.location;

import de.uni_mannheim.aware.impl.SensorNotAvailableException;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;

public class LocationNearCondition extends LocationCondition {
	private LocationData location;
	private double radius;

	public LocationNearCondition(LocationData location, double radius) 
		throws UnsupportedPlatformException, SensorNotAvailableException {
		
		super();
		
		this.location = location;
		this.radius = radius;
	}
	
	/* @Override */
	protected boolean matches(LocationData currentLocation) {
		return currentLocation.distance(location) <= radius;
	}
	
	/* @Override */
	public String toString() {
		return "{expr:\"Location in "+radius+"m radius to "+location.getLatitude()+"/"+location.getLongitude()+"\",matches:"+isConditionMet()+"}";
	}
}
