package de.uni_mannheim.aware.api.location;

import de.uni_mannheim.aware.impl.SensorNotAvailableException;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;

public class SpeedCondition extends LocationCondition {
	public static final int GREATER_THAN = 1;
	public static final int LESS_THAN = 2;
	
	private double speed;
	private int mode;

	public SpeedCondition(double speed, int mode) 
		throws UnsupportedPlatformException, SensorNotAvailableException {
		
		super();
		
		this.speed = speed;
		this.mode = mode;
	}
	
	public double getSpeed() {
		return speed;
	}
	
	public int getMode() {
		return mode;
	}
	
	/* @Override */
	protected boolean matches(LocationData currentLocation) {
		
		
		switch (getMode()) {
			case GREATER_THAN: 
				System.out.println("macthes="+(currentLocation.getSpeed() > getSpeed())+" --> "+this);
				return currentLocation.getSpeed() > getSpeed();
			case LESS_THAN: 
				System.out.println("macthes="+(currentLocation.getSpeed() < getSpeed())+" --> "+this);
				return currentLocation.getSpeed() < getSpeed();
			default: return false;
		} 
	}
	
	/* @Override */
	public String toString() {
		return "{expr:\"Speed "+((getMode() == GREATER_THAN) ? " > " : " < ")+getSpeed()+"\",matches:"+isConditionMet()+"}";
	}
}
