package de.uni_mannheim.aware.api.noise;

import de.uni_mannheim.aware.api.BooleanCondition;
import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.api.SensorFactory;
import de.uni_mannheim.aware.api.SensorListener;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;
import de.uni_mannheim.aware.impl.SensorNotAvailableException;

public abstract class NoiseLevelCondition extends BooleanCondition implements SensorListener  {
	public NoiseLevelCondition() throws UnsupportedPlatformException, SensorNotAvailableException {
		super(SensorFactory.getImpl().getNoiseLevelSensor());
		setSensorData(new NoiseLevelData());
	}
	
	public NoiseLevelData getNoiseLevelData() {
		return (NoiseLevelData) getSensorData();
	}
	
	/* @Override */
	public void sensorDataChanged(SensorData sensorData) {
		if (! (sensorData instanceof NoiseLevelData))
			return;
				
		// Update data
		NoiseLevelData data = (NoiseLevelData) sensorData;
		
		setSensorData(data);

		// Check changes
		boolean conditionMatches = matches(data);
		
		// Notify if changed
		if (isConditionMet() != conditionMatches) {
			setConditionMet(conditionMatches);	
			fireConditionChangedEvent();
		}		
	}
	
	protected abstract boolean matches(NoiseLevelData currentNoiseLevelData);	

}
