package de.uni_mannheim.aware.api.noise;

import de.uni_mannheim.aware.api.SensorData;

public class NoiseLevelData extends SensorData {
	public static double ACCURACY = 0.5;
	
	private double dB;
	
	public NoiseLevelData(){
		this.dB = -100.0;
	};
	
	public NoiseLevelData(double db){
		this.dB = db;
	}


	public double getDb() {
		return dB;
	}

	public void setDb(double dB) {
		this.dB = dB;
	} 

	/* @Override */
	public SensorData clone() {
		return new NoiseLevelData(this.dB);
	}

	/* @Override */
	public boolean equals(Object obj) {
		if (! (obj instanceof NoiseLevelData))
			return false;
		
		NoiseLevelData data = (NoiseLevelData) obj;
		return Math.abs(data.getDb() - this.dB) < ACCURACY;
	}
	
	/* @Override */
	public String toString() {
    	return "{db:" + getDb() +"}";
    }
}
