package de.uni_mannheim.aware.api.noise;

import de.uni_mannheim.aware.api.Sensor;

public interface NoiseLevelSensor extends Sensor {
	NoiseLevelData getNoiseLevel();
	
	/**
	 * Returns the milli seconds that the sensor records audio
	 * for determining the current noise level. Afterwards, the device 
	 * sleeps for sleepMillis milli seconds
	 * @see {@link NoiseLevelSensor#getSleepMillis()}
	 * @return the milli seconds, that the device records to determine the noise level
	 */
	//public int getRecordMillis();
	/**
	 * Sets the milli seconds that the sensor records audio
	 * for determining the current noise level. Afterwards, the device 
	 * <sleeps for <strong>sleepMillis</strong> milli seconds
	 * @see {@link NoiseLevelSensor#setSleepMillis()}
	 * @param recordMillis the milli seconds, that the device records to determine the noise level
	 */
	//public void setRecordMillis(int recordMillis);
	/**
	 * Returns the milli seconds that the sensor sleeps after having determined the current 
	 * noise level. 
	 * @return the milli seconds, that the device sleeps after recording audio
	 */
	//public int getSleepMillis();
	/**
	 * Sets the milli seconds that the sensor sleeps after having determined the current 
	 * noise level. 
	 * @param sleepMillis the milli seconds, that the device sleeps after recording audio
	 */
	//public void setSleepMillis(int sleepMillis);
	
}
