package de.uni_mannheim.aware.api.time;

import de.uni_mannheim.aware.api.BooleanCondition;
import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.api.SensorFactory;
import de.uni_mannheim.aware.api.SensorListener;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;

public abstract class TimeCondition extends BooleanCondition implements SensorListener {
	public TimeCondition() throws UnsupportedPlatformException {
		super(SensorFactory.getImpl().getTimeSensor());

		setSensorData(new TimeData());
	}
	
	public TimeData getTimeData() {
		return (TimeData) getSensorData();
	}
	
	/* @Override */
	public void sensorDataChanged(SensorData sensorData) {
		if (! (sensorData instanceof TimeData))
			return;
		
		// Update data
		TimeData timeData = (TimeData) sensorData; 
		setSensorData(timeData);
		//System.out.println("TIME Sensor: "+timeData);

		// Check changes
		boolean conditionMatches = matches(timeData);
		boolean conditionChanged = isConditionMet() != conditionMatches;
		
		setConditionMet(conditionMatches);

		// Notify if changed
		if (conditionChanged)
			fireConditionChangedEvent();
	}
	
	protected abstract boolean matches(TimeData timeData);		
}
