package de.uni_mannheim.aware.api.time;

import java.util.Calendar;
import java.util.Date;

import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.api.location.LocationData;

public class TimeData extends SensorData {
	private Calendar time;

	public TimeData() {
		time = Calendar.getInstance();
	}
	
	public TimeData(Calendar time) {
		this();
		this.time = time;
	}
	
	public void setTime(Calendar time) {
		this.time = time;
	}

	public Calendar getTime() {
		return time;
	}
	
	/* @Override */
	public SensorData clone() {
		TimeData clone = new TimeData();
		
		clone.setTime(getTime());
		
		return clone;
	}
	
	/* @Override */
	public boolean equals(Object obj) {
		if (! (obj instanceof TimeData))
			return false;
		
		TimeData data = (TimeData) obj;		
		
		return getTime().equals(data.getTime());
	}
	
	/* @Override */
	public String toString() {
		return "{time:"+time.getTime().getTime()+", str:\""+time.getTime()+"\"}";
	}
}
