package de.uni_mannheim.aware.api.wireless;

import de.uni_mannheim.aware.util.StringUtil;

public class WirelessAccessPoint {
	private byte[] bssid;
	private String ssid;
	private int signalStrength;
	
	public WirelessAccessPoint() {
		this(new byte[] { 0, 0, 0, 0, 0});
	}
	
	public WirelessAccessPoint(byte[] bssid) {
		this(bssid, "");
	}	
	
	public WirelessAccessPoint(byte[] bssid, String ssid) {
		this(bssid, ssid, 0);
	}
	
	public WirelessAccessPoint(byte[] bssid, String ssid, int signalStrength) {
		setBssid(bssid);
		setSsid(ssid);
		setSignalStrength(signalStrength);
	}
	
	public byte[] getBssid() {
		return bssid;
	}

	public void setBssid(byte[] bssid) {
		this.bssid = bssid;
	}
	
	public String getSsid() {
		return ssid;
	}
	
	public void setSsid(String ssid) {
		this.ssid = ssid;
	}
	
	public int getSignalStrength() {
		return signalStrength;
	}
	
	public void setSignalStrength(int signalStrength) {
		this.signalStrength = signalStrength;
	}	
	
	/**
	 * TODO only checks BSSID so far, what if signal strength changes?
	 */
	/* @Override */
	public boolean equals(Object obj) {
		if (obj == null || !(obj instanceof WirelessAccessPoint))
			return false;
		
		WirelessAccessPoint ap = (WirelessAccessPoint) obj;
		byte[] apBSSID = ap.getBssid();
		
		if (apBSSID.length != bssid.length)
			return false;
		
		for(int i=0; i<apBSSID.length; i++) {
			if (apBSSID[i] != bssid[i])
				return false;
		}
		
		return true;
	}
	
	/* @Override */
	public String toString() {
		return "{bssid: \""+StringUtil.getHexString(getBssid(), ":")+"\","
			+ "ssid: \""+getSsid()+"\","
			+ "signal: "+getSignalStrength()+"}";
	}	
}
