package de.uni_mannheim.aware.api.wireless;

import java.util.Vector;

import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.util.StringUtil;
import de.uni_mannheim.aware.util.VectorUtil;

public class WirelessData extends SensorData {
	private Vector devices;
	private Vector discovered;
	private Vector vanished;

	public WirelessData() {
		devices = new Vector();
		discovered = new Vector();
		vanished = new Vector();
	}
	
	public Vector getDevices() {
		return devices;
	}

	public void setDevices(Vector devices) {
		this.devices = devices;
	}

	public Vector getDiscovered() {
		return discovered;
	}

	public void setDiscovered(Vector discovered) {
		this.discovered = discovered;
	}

	public Vector getVanished() {
		return vanished;
	}

	public void setVanished(Vector vanished) {
		this.vanished = vanished;
	}
	
	/* @Override */
	public SensorData clone() {
		WirelessData clone = new WirelessData();
		
		clone.setDevices(getDevices());
		clone.setDiscovered(getDiscovered());
		clone.setVanished(getVanished());
		
		return clone;
	}

	/* @Override */
	public boolean equals(Object obj) {
		if (! (obj instanceof WirelessData))
			return false;
		
		WirelessData data = (WirelessData) obj;
		
		// Compare device vectors 
		return VectorUtil.equalElements(data.getDevices(), getDevices())
			&& VectorUtil.equalElements(data.getDiscovered(), getDiscovered())
			&& VectorUtil.equalElements(data.getVanished(), getVanished());
	}
	
	/* @Override */
	public String toString() {
		return "{devices:["+StringUtil.join(",", VectorUtil.toArray(getDevices()))+"],"
			+ "discovered:["+StringUtil.join(",", VectorUtil.toArray(getDiscovered()))+"],"
			+ "vanished:["+StringUtil.join(",", VectorUtil.toArray(getVanished()))+"]}";
    }	
}
