package de.uni_mannheim.aware.api.wireless;

import de.uni_mannheim.aware.impl.SensorNotAvailableException;
import de.uni_mannheim.aware.impl.UnsupportedPlatformException;
import de.uni_mannheim.aware.util.StringUtil;

public class WirelessNearCondition extends WirelessCondition {
	private WirelessAccessPoint accessPoint;
	
	public WirelessNearCondition(WirelessAccessPoint accessPoint)
			throws UnsupportedPlatformException, SensorNotAvailableException {
		
		super();
		this.accessPoint = accessPoint;
	}
	
	/* @Override */
	protected boolean matches(WirelessData currentWirelessData) {
		return currentWirelessData.getDevices().contains(accessPoint);
	}

	/* @Override */
	public String toString() {
		return "{expr:\"Wifi AP "+StringUtil.getHexString(accessPoint.getBssid(),":")+" exist\",matches:"+isConditionMet()+"}";
	}

}
