package de.uni_mannheim.aware.impl;
 
import java.util.Enumeration;
import java.util.Hashtable;

import de.uni_mannheim.aware.api.SensorData;
import de.uni_mannheim.aware.api.custom.CustomData;
import de.uni_mannheim.aware.api.custom.CustomSensor;

public class CommonCustomSensor extends CommonSensor implements CustomSensor {
	private static CommonCustomSensor instance;
	private CustomData data;

	private CommonCustomSensor() {
		super();
		data = new CustomData();		
	}
	
	public static CommonCustomSensor getInstance() {
		if (instance != null)
			return instance;
		
		instance = new CommonCustomSensor();
		return instance;
	}
	
	/* @Override */
	public synchronized Object get(String name) {
		return data.get(name);
	}
	
	/* @Override */
	public synchronized void put(String name, Object value) {
		Object oldValue = data.get(name);		
					
		data.put(name, value);
		
		boolean changed =
			   (value != null && !value.equals(oldValue))
			|| (value == null && oldValue != null);

		System.out.println("[CommonCustomSensor] Value for "+name+": NEW = "+value+", OLD = "+oldValue+" --> changed: "+changed);
/*
		for (Enumeration e = map.keys(); e.hasMoreElements(); ) { 
			String key = (String) e.nextElement();  
			System.out.println(key + " = "+map.get(key)); 
		}
*/
		
		System.out.println("Sensor data NOW: "+data);
		if (changed)
			fireSensorDataChangedEvent(data);		
	}

	
	/* @Override */
	public synchronized CustomData getCustomData() {
		return data;
	}
	
}
