package de.uni_mannheim.aware.impl.emu;

import de.uni_mannheim.aware.api.SensorFactory;
import de.uni_mannheim.aware.api.battery.BatterySensor;
import de.uni_mannheim.aware.api.bluetooth.BluetoothSensor;
import de.uni_mannheim.aware.api.location.LocationSensor;
import de.uni_mannheim.aware.api.location.gps.GPSSensor;
import de.uni_mannheim.aware.api.movement.MovementSensor;
import de.uni_mannheim.aware.api.noise.NoiseLevelSensor;
import de.uni_mannheim.aware.api.time.TimeSensor;
import de.uni_mannheim.aware.api.wireless.WirelessSensor;
import de.uni_mannheim.aware.impl.CommonNoiseLevelSensor;
import de.uni_mannheim.aware.impl.CommonTimeSensor;
import de.uni_mannheim.aware.impl.SensorNotAvailableException;
import de.uni_mannheim.aware.impl.nokia.NokiaLocationSensor;

final public class EmulatedSensorFactory extends SensorFactory {
	/* @Override */
	public LocationSensor getLocationSensor() throws SensorNotAvailableException {
		return EmulatedLocationPathSensor.getInstance();
		//return EmulatedLocationSensor.getInstance();
		//return NokiaLocationSensor.getInstance();
	}

	/* @Override */
	public BluetoothSensor getBluetoothSensor() throws SensorNotAvailableException {
		return EmulatedBluetoothSensor.getInstance();
	}

	public MovementSensor getMovementSensor() throws SensorNotAvailableException {
		// TODO emulated sensor
		throw new SensorNotAvailableException();
	}

	public WirelessSensor getWirelessSensor() throws SensorNotAvailableException {
		return EmulatedWirelessSensor.getInstance();
	}

	public BatterySensor getBatterySensor() throws SensorNotAvailableException {
		// TODO emulated sensor
		throw new SensorNotAvailableException();
	}
}
