package de.uni_mannheim.aware.impl.nokia;

import de.uni_mannheim.aware.api.SensorFactory;
import de.uni_mannheim.aware.api.battery.BatterySensor;
import de.uni_mannheim.aware.api.bluetooth.BluetoothSensor;
import de.uni_mannheim.aware.api.location.LocationSensor;
import de.uni_mannheim.aware.api.location.gps.GPSSensor;
import de.uni_mannheim.aware.api.movement.MovementSensor;
import de.uni_mannheim.aware.api.noise.NoiseLevelSensor;
import de.uni_mannheim.aware.api.time.TimeSensor;
import de.uni_mannheim.aware.api.wireless.WirelessSensor;
import de.uni_mannheim.aware.impl.CommonBluetoothSensor;
import de.uni_mannheim.aware.impl.CommonNoiseLevelSensor;
import de.uni_mannheim.aware.impl.SensorNotAvailableException;
import de.uni_mannheim.aware.impl.emu.EmulatedLocationPathSensor;
import de.uni_mannheim.aware.impl.emu.EmulatedLocationSensor;

final public class NokiaSensorFactory extends SensorFactory {

	public LocationSensor getLocationSensor() throws SensorNotAvailableException {
		System.err.println("NokiaSensorFactory   - WARNING !!!!!!!!!!!!!!");
		return EmulatedLocationPathSensor.getInstance();
		//return NokiaLocationSensor.getInstance();
	}

	public MovementSensor getMovementSensor() throws SensorNotAvailableException {
		throw new SensorNotAvailableException();
	}

	public WirelessSensor getWirelessSensor() throws SensorNotAvailableException {
		return NokiaWirelessSensor.getInstance();
	}

	public BatterySensor getBatterySensor() throws SensorNotAvailableException {
		return NokiaBatterySensor.getInstance();
	}
}

