package de.uni_mannheim.aware.util;

import java.util.Calendar;
import java.util.Date;

public class DateUtil {
	/**
	 * @see http://java.sun.com/javase/6/docs/api/java/util/GregorianCalendar.html#GregorianCalendar%28int,%20int,%20int,%20int,%20int,%20int%29
	 * @param year
	 * @return
	 */
	public static Date mkTime(int year, int month, int dayOfMonth, 
			int hourOfDay, int minute, int second) {
		
		Calendar cal = Calendar.getInstance();
		
		cal.set(Calendar.YEAR, year);
		cal.set(Calendar.MONTH, month);
		cal.set(Calendar.DAY_OF_MONTH, dayOfMonth);
		cal.set(Calendar.HOUR_OF_DAY, hourOfDay);
		cal.set(Calendar.MINUTE, minute);
		cal.set(Calendar.SECOND, second);
		
		return cal.getTime();		
	}
	
	/**
	 * @see http://java.sun.com/javase/6/docs/api/java/util/GregorianCalendar.html#GregorianCalendar%28int,%20int,%20int,%20int,%20int%29
	 * @param year
	 * @param month
	 * @param dayOfMonth
	 * @param hourOfDay
	 * @param minute
	 * @return
	 */
	public static Date mkTime(int year, int month, int dayOfMonth, 
			int hourOfDay, int minute) {
		
		return mkTime(year, month, dayOfMonth, hourOfDay, minute, 0);
	}
	
	/**
	 * @see http://java.sun.com/javase/6/docs/api/java/util/GregorianCalendar.html#GregorianCalendar%28int,%20int,%20int%29
	 * @param year
	 * @param month
	 * @param dayOfMonth
	 * @return
	 */
	public static Date mkTime(int year, int month, int dayOfMonth) {
		return mkTime(year, month, dayOfMonth, 0, 0, 0);
	}
	
	public static String dateToTimeString(Date date){
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		int hour = cal.get(Calendar.HOUR_OF_DAY);
		int minute = cal.get(Calendar.MINUTE);
		int second = cal.get(Calendar.SECOND);
		StringBuffer s = new StringBuffer();
		if(hour < 10 )
			s.append("0");
		s.append(hour);
		s.append(":");
		if(minute < 10)
			s.append("0");
		s.append(minute);
		s.append(":");
		if(second < 10)
			s.append("0");
		s.append(second);
		return s.toString();
	}
	

}
