package de.uni_mannheim.aware.util;

import java.io.IOException;
import java.io.InputStream;

public class StringUtil {
	public static String getHexString(byte[] b) {
		return getHexString(b, "");
	}
	
	public static String getHexString(byte[] b, String separator) {
	  String result = "";
	  
	  for (int i=0; i < b.length; i++) {
		  result += Integer.toString( ( b[i] & 0xff ) + 0x100, 16).substring( 1 );
	    
		  if (i < b.length-1)
			  result += separator;
	  }
	  	  
	  return result;
	}
	
	/**
	 * Transforms a C-string (NULL-terminated) into a Java string.
	 *   
	 * @param b C-string byte array
	 * @return Java string
	 */
	public static String getCString(byte[] b) {
    	if (b.length == 0 || b[0] == 0x00)
    		return "";
		
		int len = 0;    	
    	while (len++ < b.length && b[len] != 0)
    		{ /* Nothing */ }
    	
    	return new String(b, 0, len);		
	}	
	
	public static String join(String delimiter, Object[] objects) {
		String result = "";
		
		for(int i=0; i<objects.length; i++) {
			result += objects[i].toString();
			
			if (i != objects.length-1)
				result += delimiter;
		}
		
		return result;			
	}
	

}
