package de.uni_mannheim.aware.api;

import java.util.Enumeration;

abstract public class FuzzyCondition extends Condition{
	protected double score = 0.0;

	public FuzzyCondition(Sensor sensor) {
		super(sensor);
	}

	public double getScore() {
		return score;
	}
	
	public void setScore(double score) {
		this.score = score;
	}
	
	protected void fireConditionChangedEvent() {
		synchronized (listeners) {
			for (Enumeration e = listeners.elements(); e.hasMoreElements(); )				
				((FuzzyConditionListener) e.nextElement()).conditionChanged(this, score);
		}
	}	
	
	public void addConditionListener(FuzzyConditionListener listener) {
		synchronized (listeners) {
			if (listeners.contains(listener))
				return;
			
			listeners.addElement(listener);			
		}
	}
	
	public boolean removeConditionListener(FuzzyConditionListener listener) {
		synchronized (listeners) {
			return listeners.removeElement(listener);			
		}
	}
	
}
